package magic.cardBuilder;

public enum CardResource {
    
    multiFrame("mcard.jpg"),
    artifactFrame("acard.jpg"),
    colorlessFrame("ccard.jpg"),
    redFrame("rcard.jpg"),
    blackFrame("bcard.jpg"),
    blueFrame("ucard.jpg"),
    greenFrame("gcard.jpg"),
    whiteFrame("wcard.jpg"),
    landFrame("lcard.jpg"),
    vehicleFrame("vcard.jpg"),
    redPTPanel("rpt.png"),
    blackPTPanel("bpt.png"),
    bluePTPanel("upt.png"),
    greenPTPanel("gpt.png"),
    whitePTPanel("wpt.png"),
    colorlessPTPanel("cpt.png"),
    artifactPTPanel("apt.png"),
    multiPTPanel("mpt.png"),
    vehiclePTPanel("vpt.png"),
    gainColorBlend("color_blend.png"),
    gainHybridBlend("blendingMask.png"),
    gainHybridBanner("hybrid_blend.png"),
    defaultWhite(ResourceManager.IMAGES_FOLDER, "default_white.jpg"),
    defaultBlue(ResourceManager.IMAGES_FOLDER, "default_blue.jpg"),
    defaultBlack(ResourceManager.IMAGES_FOLDER, "default_black.jpg"),
    defaultRed(ResourceManager.IMAGES_FOLDER, "default_red.jpg"),
    defaultGreen(ResourceManager.IMAGES_FOLDER, "default_green.jpg"),
    defaultArtifact(ResourceManager.IMAGES_FOLDER, "default_artifact.jpg"),
    defaultLand(ResourceManager.IMAGES_FOLDER, "default_land.jpg"),
    defaultColorless(ResourceManager.IMAGES_FOLDER, "default_colorless.jpg"),
    defaultMulti(ResourceManager.IMAGES_FOLDER, "default_multi.jpg"),
    defaultHybridBlend(ResourceManager.IMAGES_FOLDER, "imageHybridBlend.png"),
    whiteLandImage("watermark/watermark_w.png"),
    blueLandImage("watermark/watermark_u.png"),
    blackLandImage("watermark/watermark_b.png"),
    redLandImage("watermark/watermark_r.png"),
    greenLandImage("watermark/watermark_g.png"),
    bgLandImage("watermark/watermark_bg.png"),
    brLandImage("watermark/watermark_br.png"),
    guLandImage("watermark/watermark_gu.png"),
    gwLandImage("watermark/watermark_gw.png"),
    rgLandImage("watermark/watermark_rg.png"),
    rwLandImage("watermark/watermark_rw.png"),
    ubLandImage("watermark/watermark_ub.png"),
    urLandImage("watermark/watermark_ur.png"),
    wbLandImage("watermark/watermark_wb.png"),
    wuLandImage("watermark/watermark_wu.png"),
    artifactNyx("nyx/acard.jpg"),
    colorlessNyx("nyx/ccard.jpg"),
    landNyx("nyx/clcard.jpg"),
    whiteNyx("nyx/wcard.jpg"),
    blueNyx("nyx/ucard.jpg"),
    blackNyx("nyx/bcard.jpg"),
    redNyx("nyx/rcard.jpg"),
    greenNyx("nyx/gcard.jpg"),
    multiNyx("nyx/mcard.jpg"),
    colorlessTokenFrame("token/ccard.jpg"),
    colorlessTokenFrameText("token/ccard2.jpg"),
    artifactTokenFrame("token/acard.jpg"),
    artifactTokenFrameText("token/acard2.jpg"),
    whiteTokenFrame("token/wcard.jpg"),
    whiteTokenFrameText("token/wcard2.jpg"),
    blueTokenFrame("token/ucard.jpg"),
    blueTokenFrameText("token/ucard2.jpg"),
    blackTokenFrame("token/bcard.jpg"),
    blackTokenFrameText("token/bcard2.jpg"),
    redTokenFrame("token/rcard.jpg"),
    redTokenFrameText("token/rcard2.jpg"),
    greenTokenFrame("token/gcard.jpg"),
    greenTokenFrameText("token/gcard2.jpg"),
    multiTokenFrame("token/mcard.jpg"),
    multiTokenFrameText("token/mcard2.jpg"),
    gainColorTokenBlend("token/color_blend.png"),
    gainColorTokenBlendText("token/color_blend2.png"),
    gainTokenBanner("token/hybrid_blend.png"),
    gainTokenBannerText("token/hybrid_blend2.png"),
    artifactLevellerBox("leveller/aLeveller.jpg"),
    whiteLevellerBox("leveller/wLeveller.jpg"),
    whiteLandLevellerBox("leveller/wlLeveller.jpg"),
    blueLevellerBox("leveller/uLeveller.jpg"),
    blueLandLevellerBox("leveller/ulLeveller.jpg"),
    blackLevellerBox("leveller/bLeveller.jpg"),
    blackLandLevellerBox("leveller/blLeveller.jpg"),
    redLevellerBox("leveller/rLeveller.jpg"),
    redLandLevellerBox("leveller/rlLeveller.jpg"),
    greenLevellerBox("leveller/gLeveller.jpg"),
    greenLandLevellerBox("leveller/glLeveller.jpg"),
    gainTextBoxHybridBlend("leveller/blendingMaskBox.png"),
    multiLevellerBox("leveller/mLeveller.jpg"),
    multiLandLevellerBox("leveller/mlLeveller.jpg"),
    colorlessLevellerBox("leveller/cLeveller.jpg"),
    colorlessLandLevellerBox("leveller/clLeveller.jpg"),
    artifactPlaneswalkerFrame("planeswalker/acard.jpg"),
    whitePlaneswalkerFrame("planeswalker/wcard.jpg"),
    bluePlaneswalkerFrame("planeswalker/ucard.jpg"),
    blackPlaneswalkerFrame("planeswalker/bcard.jpg"),
    redPlaneswalkerFrame("planeswalker/rcard.jpg"),
    greenPlaneswalkerFrame("planeswalker/gcard.jpg"),
    multiPlaneswalkerFrame("planeswalker/mcard.jpg"),
    colorlessPlaneswalkerFrame("planeswalker/clear.jpg"),
    gainPlaneswalkerHybridBanner("planeswalker/hybrid_blend.png"),
    gainPlaneswalkerColorBlend("planeswalker/color_blend.png"),
    artifactPlaneswalker4("planeswalker/acard2.jpg"),
    whitePlaneswalker4("planeswalker/wcard2.jpg"),
    bluePlaneswalker4("planeswalker/ucard2.jpg"),
    blackPlaneswalker4("planeswalker/bcard2.jpg"),
    redPlaneswalker4("planeswalker/rcard2.jpg"),
    greenPlaneswalker4("planeswalker/gcard2.jpg"),
    multiPlaneswalker4("planeswalker/mcard2.jpg"),
    colorlessPlaneswalker4("planeswalker/clear2.jpg"),
    gainPlaneswalker4HybridBanner("planeswalker/hybrid_blend2.png"),
    gainPlaneswalker4ColorBlend("planeswalker/color_blend2.png"),
    loyaltyPanel("planeswalker/loyalty.png"),
    loyaltyUp("planeswalker/loyaltyup.png"),
    loyaltyDown("planeswalker/loyaltydown.png"),
    loyaltyEven("planeswalker/loyaltynaught.png"),
    whiteDevoidFrame("devoid/wcard.png"),
    blueDevoidFrame("devoid/ucard.png"),
    blackDevoidFrame("devoid/bcard.png"),
    redDevoidFrame("devoid/rcard.png"),
    greenDevoidFrame("devoid/gcard.png"),
    colorlessDevoidFrame("devoid/ccard.png"),
    artifactDevoidFrame("devoid/acard.png"),
    multiDevoidFrame("devoid/mcard.png"),
    artifactSymbol(ResourceManager.IMAGES_FOLDER, "artifactSymbol.png"),
    creatureSymbol(ResourceManager.IMAGES_FOLDER, "creatureSymbol.png"),
    enchantmentSymbol(ResourceManager.IMAGES_FOLDER, "enchantmentSymbol.png"),
    instantSymbol(ResourceManager.IMAGES_FOLDER, "instantSymbol.png"),
    landSymbol(ResourceManager.IMAGES_FOLDER, "landSymbol.png"),
    multiSymbol(ResourceManager.IMAGES_FOLDER, "multiSymbol.png"),
    planeswalkerSymbol(ResourceManager.IMAGES_FOLDER, "planeswalkerSymbol.png"),
    sorcerySymbol(ResourceManager.IMAGES_FOLDER, "sorcerySymbol.png"),
    magarenaSymbol(ResourceManager.IMAGES_FOLDER, "magarenaSymbol.png"),
    artifactTransform("transform/acard.jpg"),
    artifactHidden("transform/acard2.jpg"),
    colorlessTransform("transform/ccard.jpg"),
    colorlessHidden("transform/ccard2.jpg"),
    colorlessLandTransform("transform/clcard.jpg"),
    colorlessLandHidden("transform/clcard2.jpg"),
    whiteTransform("transform/wcard.jpg"),
    whiteHidden("transform/wcard2.jpg"),
    whiteLandTransform("transform/wlcard.jpg"),
    whiteLandHidden("transform/wlcard2.jpg"),
    blueTransform("transform/ucard.jpg"),
    blueHidden("transform/ucard2.jpg"),
    blueLandTransform("transform/ulcard.jpg"),
    blueLandHidden("transform/ulcard2.jpg"),
    blackTransform("transform/bcard.jpg"),
    blackHidden("transform/bcard2.jpg"),
    blackLandTransform("transform/blcard.jpg"),
    blackLandHidden("transform/blcard2.jpg"),
    redTransform("transform/rcard.jpg"),
    redHidden("transform/rcard2.jpg"),
    redLandTransform("transform/rlcard.jpg"),
    redLandHidden("transform/rlcard2.jpg"),
    greenTransform("transform/gcard.jpg"),
    greenHidden("transform/gcard2.jpg"),
    greenLandTransform("transform/glcard.jpg"),
    greenLandHidden("transform/glcard2.jpg"),
    multiTransform("transform/mcard.jpg"),
    multiHidden("transform/mcard2.jpg"),
    multiLandTransform("transform/mlcard.jpg"),
    multiLandHidden("transform/mlcard2.jpg"),
    gainTransformColorBlend("transform/color_blend.png"),
    gainTransformHybridBanner("transform/hybrid_blend.png"),
    artifactPlaneswalkerTransform("transform/planeswalker/acard.jpg"),
    artifactPlaneswalkerHidden("transform/planeswalker/acard2.jpg"),
    whitePlaneswalkerTransform("transform/planeswalker/wcard.jpg"),
    whitePlaneswalkerHidden("transform/planeswalker/wcard2.jpg"),
    bluePlaneswalkerTransform("transform/planeswalker/ucard.jpg"),
    bluePlaneswalkerHidden("transform/planeswalker/ucard2.jpg"),
    blackPlaneswalkerTransform("transform/planeswalker/bcard.jpg"),
    blackPlaneswalkerHidden("transform/planeswalker/bcard2.jpg"),
    redPlaneswalkerTransform("transform/planeswalker/rcard.jpg"),
    redPlaneswalkerHidden("transform/planeswalker/rcard2.jpg"),
    greenPlaneswalkerTransform("transform/planeswalker/gcard.jpg"),
    greenPlaneswalkerHidden("transform/planeswalker/gcard2.jpg"),
    multiPlaneswalkerTransform("transform/planeswalker/mcard.jpg"),
    multiPlaneswalkerHidden("transform/planeswalker/mcard2.jpg"),
    gainPlaneswalkerTransformHybridBanner("transform/planeswalker/hybrid_blend.png"),
    getPlaneswalkerImageBlend("planeswalker/imageMask.png"),
    artifactHiddenPTPanel("transform/apt2.png"),
    colorlessHiddenPTPanel("transform/cpt2.png"),
    whiteHiddenPTPanel("transform/wpt2.png"),
    blueHiddenPTPanel("transform/upt2.png"),
    blackHiddenPTPanel("transform/bpt2.png"),
    redHiddenPTPanel("transform/rpt2.png"),
    greenHiddenPTPanel("transform/gpt2.png"),
    multiHiddenPTPanel("transform/mpt2.png"),
    daySymbol("transform/sun_circle.png"),
    nightSymbol("transform/night_circle.png"),
    moonSymbol("transform/moon.png"),
    eldraziSymbol("transform/eldrazi.png"),
    planeswalkerTypeSymbol("transform/planeswalker.png"),
    sparkSymbol("transform/ccorner.png"),
    common("rarity/Common.png"),
    uncommon("rarity/Uncommon.png"),
    rare("rarity/Rare.png"),
    mythic("rarity/Mythic.png"),
    artifactMiracle("miracle/aMiracleOverlay.png"),
    blackMiracle("miracle/bMiracleOverlay.png"),
    colorlessMiracle("miracle/cMiracleOverlay.png"),
    multiMiracle("miracle/mMiracleOverlay.png"),
    redMiracle("miracle/rMiracleOverlay.png"),
    blueMiracle("miracle/uMiracleOverlay.png"),
    whiteMiracle("miracle/wMiracleOverlay.png"),
    greenMiracle("miracle/gMiracleOverlay.png"),
    blackLandBox("land/bLandBox.jpg"),
    blueLandBox("land/uLandBox.jpg"),
    redLandBox("land/rLandBox.jpg"),
    greenLandBox("land/gLandBox.jpg"),
    whiteLandBox("land/wLandBox.jpg"),
    multiLandBox("land/mLandBox.jpg"),
    tokenImageMaskSmall("token/imagemask2.png"),
    tokenImageMaskLarge("token/imagemask.png"),
    ;
    

    public final String path;

    private CardResource(final String aPath) {
        path = ResourceManager.FRAMES_FOLDER + aPath;
    }
    
    private CardResource(final String folder, final String aPath) {
        path = folder + aPath;
    }
}
